Clazz.declarePackage ("J.shapespecial");
Clazz.load (null, "J.shapespecial.Polyhedron", ["java.util.Hashtable", "JU.AU", "$.P3"], function () {
c$ = Clazz.decorateAsClass (function () {
this.modelIndex = 0;
this.centralAtom = null;
this.points = null;
this.nVertices = 0;
this.visible = false;
this.normixes = null;
this.planes = null;
this.visibilityFlags = 0;
this.collapsed = false;
this.faceCenterOffset = 0;
this.distanceFactor = 0;
this.isFullyLit = false;
this.isValid = true;
this.colixEdge = 0;
Clazz.instantialize (this, arguments);
}, J.shapespecial, "Polyhedron");
Clazz.defineMethod (c$, "getInfo", 
function () {
var info =  new java.util.Hashtable ();
info.put ("vertexCount", Integer.$valueOf (this.nVertices));
info.put ("modelIndex", Integer.$valueOf (this.centralAtom.mi));
info.put ("planeCount", Integer.$valueOf (this.planes.length));
info.put ("_ipt", Integer.$valueOf (this.centralAtom.i));
info.put ("center", JU.P3.newP (this.centralAtom));
info.put ("vertices", JU.AU.arrayCopyPt (this.points, this.nVertices));
info.put ("polygons", JU.AU.arrayCopyII (this.planes, this.planes.length));
return info;
});
Clazz.makeConstructor (c$, 
function (centralAtom, nVertices, nPoints, planeCount, otherAtoms, normixes, planes, collapsed, faceCenterOffset, distanceFactor) {
this.centralAtom = centralAtom;
this.modelIndex = centralAtom.mi;
this.nVertices = nVertices;
this.points =  new Array (nPoints + 1);
this.visible = true;
this.normixes =  Clazz.newShortArray (planeCount, 0);
this.planes = JU.AU.newInt2 (planeCount);
for (var i = nPoints + 1; --i >= 0; ) this.points[i] = otherAtoms[i];

for (var i = planeCount; --i >= 0; ) this.normixes[i] = normixes[i];

for (var i = planeCount; --i >= 0; ) this.planes[i] = planes[i];

this.collapsed = collapsed;
this.faceCenterOffset = faceCenterOffset;
this.distanceFactor = distanceFactor;
}, "JM.Atom,~N,~N,~N,~A,~A,~A,~B,~N,~N");
Clazz.defineMethod (c$, "getState", 
function () {
var ptemp =  new JU.P3 ();
var s = "({" + this.centralAtom.i + "}) TO [";
for (var i = 0; i < this.nVertices; i++) {
ptemp.setT (this.points[i]);
s += ptemp;
}
s += "]";
return "  polyhedra " + s + (this.collapsed ? " collapsed" : "") + " distanceFactor " + this.distanceFactor + " faceCenterOffset " + this.faceCenterOffset + (this.isFullyLit ? " fullyLit" : "") + ";" + (this.visible ? "" : "polyhedra off;") + "\n";
});
});
